SystemOrganization addCategory: #'Conman-Core'!
SystemOrganization addCategory: #'Conman-Core-Tests'!
SystemOrganization addCategory: #'Conman-Web'!

!SUElement methodsFor: '*conman' stamp: 'srh 6/3/2007 13:10'!
collect: aBlock
	self call: 'collect' argument: 
		((SUFunction on: self canvas block: aBlock arguments: 
			(Array with: SUElementReference)) return: true).! !

!SUElement methodsFor: '*conman' stamp: 'srh 6/3/2007 12:32'!
each: aBlock
	self call: 'each' argument: 
		(SUFunction on: self canvas block: aBlock arguments: 
			(Array with: SUElementReference)).! !

!SUElement methodsFor: '*conman' stamp: 'srh 6/3/2007 11:50'!
invoke: aString arguments: anArray
	self call: 'invoke' arguments: (Array with: aString), anArray! !

!SUElement methodsFor: '*conman' stamp: 'srh 6/3/2007 13:11'!
pluck: aString
	self call: 'pluck' argument: aString! !

WAComponent subclass: #CMComponent
	instanceVariableNames: 'enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMComponent methodsFor: 'accessing' stamp: 'srh 5/29/2007 23:16'!
convention
	^self session convention! !

!CMComponent methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:11'!
disable
	enabled := false.! !

!CMComponent methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:16'!
enable
	enabled := self convention notNil.! !

!CMComponent methodsFor: 'testing' stamp: 'srh 5/29/2007 22:10'!
enabled
	^enabled! !

!CMComponent methodsFor: 'initialize-release' stamp: 'srh 5/29/2007 22:10'!
initialize
	super initialize.
	enabled := true.! !

!CMComponent methodsFor: 'rendering' stamp: 'srh 5/31/2007 20:37'!
lightbox: aComponent
	self session ajax 
		ifTrue: [ ^super lightbox: aComponent ] 
		ifFalse: [ ^self call: aComponent ].! !

!CMComponent methodsFor: 'rendering' stamp: 'srh 5/31/2007 20:30'!
renderField: anInputType on: aSelector of: anObject titled: aTitle on: html 
	html div: 
			[(html label)
				for: aSelector;
				with: aTitle , ': '.
			(html perform: anInputType)
				on: aSelector of: anObject;
				id: aSelector]! !

!CMComponent methodsFor: 'specialisation' stamp: 'srh 5/29/2007 22:10'!
title
	^self subclassResponsibility.! !

!CMComponent methodsFor: 'rendering' stamp: 'srh 6/3/2007 21:59'!
updateId: anId callback: aBlock perform: aSelector on: html
	^(html anchor callback: aBlock; onClick: (self session ajax ifTrue: [
		html updater id: anId; callback: [ :r | aBlock value. self perform: aSelector with: r]; return: false 
	]))
! !

CMComponent subclass: #CMConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 21:04'!
renderContentOn: html
	html form: [
		self renderField: #checkbox on: #ajax of:  self session titled:  'Enable Ajax' on: html.
		self session ajax ifTrue: [
			self renderField: #checkbox on: #inlineEdit of: self session titled: 'Use inline editing' on: html.
		].
		html submitButton value: 'Save'.
	]! !

!CMConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 20:25'!
title
	^'Configuration'! !

CMComponent subclass: #CMConman
	instanceVariableNames: 'children content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMConman class methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 21:45'!
canBeRoot
	^true! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:04'!
children
	^Array with: content.! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:02'!
initialize
	super initialize.
	children := OrderedCollection new.
	content := children add: CMHome new.
	children add: CMRooms new.
	children add: CMParticipants new.
	children add: CMEvents new.
	children add: CMLoadSave new.
	children add: CMConfiguration new.! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 16:21'!
renderContentOn: html 
	html script: (
		SUResponders new 
			onCreate: ((SUSelector new name: 'body') do: [ :e | e element  addClassName: #busy]);
			onComplete: ((SUSelector new name: 'body') do: [ :e | e element  removeClassName: #busy])
	).

	(html div)
		id: 'heading';
		with: [self renderHeadingOn: html].
	(html div)
		id: 'nav';
		with: [self renderNavOn: html].
	(html div)
		id: 'pageHeading';
		with: [self renderPageHeadingOn: html].
	(html div)
		id: 'pageBody';
		with: [self renderPageBodyOn: html]! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 20:16'!
renderHeadingOn: html
	self convention isNil  
		ifTrue: [ html heading level: 1; with: [html space] ]
		ifFalse: [		 
			html heading 
				level: 1; 
				script: (self session inlineEdit ifTrue: [
				html inPlaceEditor 
					triggerInPlaceEditor: [ :value | self convention name: value ];
					callback: [ :r | r render: self convention name ]
				]);
			with: self convention name 	
		].
	html paragraph: 'Conman convention management system'! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 16:21'!
renderNavOn: html.
	html unorderedList: [ 
		children do: [ :c | 
			| id |
			id := html nextId.
			c enabled ifTrue: [
				html listItem id: id; class: ((c = content) ifTrue:  ['active'] ifFalse: ['']); with: [ 
					html anchor 
						callback: [ content := c ]; 
						onClick:(self session ajax ifTrue: [
							(
							html evaluator callback: [ :script | 
								content := c.
								script element id: 'pageHeading'; render: [ :r | self renderPageHeadingOn: r].
								script element id: 'pageBody'; render: [ :r | self renderPageBodyOn: r ].
								(script element id: id) siblings invoke: #removeClassName arguments: (Array with: #active).
								script element id: id; addClassName: #active.
							]; 
							return: false)
						]);
						with: c title.
				]
			]
		].	
].! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 13:36'!
renderPageBodyOn: html 
	html render: content! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 13:36'!
renderPageHeadingOn: html
	html heading level: 2; with: content title.! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 6/2/2007 23:04'!
updateRoot: anHtmlRoot
	| t |
	super updateRoot: anHtmlRoot.
	t := 'Conman'.
	self convention ifNotNil: [ t := t, ': ', self convention name ].
	anHtmlRoot 
		title: t.
	anHtmlRoot	stylesheet 
		url: CMFileLibrary  / #conmanCss! !

CMComponent subclass: #CMEditor
	instanceVariableNames: 'item'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMEditor class methodsFor: 'instance creation' stamp: 'srh 5/31/2007 23:41'!
for: anItem
	^self new item: anItem! !

!CMEditor methodsFor: 'actions' stamp: 'srh 5/31/2007 23:00'!
cancel
	self answer: false.! !

!CMEditor methodsFor: 'accessing' stamp: 'srh 5/31/2007 22:58'!
item: anItem
	item := anItem! !

!CMEditor methodsFor: 'rendering' stamp: 'srh 5/31/2007 23:00'!
renderContentOn: html 
	html form: [
		self renderFieldsOn: html.
		html submitButton on: #save of: self.
		html cancelButton on: #cancel of: self
	]! !

!CMEditor methodsFor: 'rendering' stamp: 'srh 5/31/2007 22:58'!
renderFieldsOn: html
	^self subclassResponsibility.! !

!CMEditor methodsFor: 'rendering' stamp: 'srh 5/31/2007 23:38'!
renderTextArea: aName for: aSelector on: html
	self renderField: #textArea on: aSelector  of: item titled: aName on: html! !

!CMEditor methodsFor: 'rendering' stamp: 'srh 5/31/2007 23:38'!
renderTextInput: aName for: aSelector on: html
	self renderField: #textInput on: aSelector  of: item titled: aName on: html! !

!CMEditor methodsFor: 'actions' stamp: 'srh 5/31/2007 23:00'!
save
	self answer: true.! !

CMEditor subclass: #CMEventEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMEventEditor methodsFor: 'rendering' stamp: 'srh 5/31/2007 23:39'!
renderFieldsOn: html 
	self renderTextInput: 'Name' for: #name on: html.
	self renderTextArea: 'Description' for: #description on: html.! !

CMEditor subclass: #CMParticipantEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMParticipantEditor methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 23:40'!
renderFieldsOn: html 
	self renderTextInput: 'Name' for: #name on: html.
	self renderTextArea: 'Bio' for: #bio on: html.
! !

CMEditor subclass: #CMRoomEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMRoomEditor methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:09'!
renderFieldsOn: html 
	self renderTextInput: 'Name' for: #name on: html.
	self renderTextInput: 'Capacity' for: #capacity on: html.
	self renderTextArea: 'Description' for: #description on: html.
! !

CMComponent subclass: #CMHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMHome methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:16'!
enabled
	^true! !

!CMHome methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 21:50'!
renderContentOn: html
	self convention ifNotNil: [
		html paragraph: 'Events: ', self convention events size printString.
		html paragraph: 'Rooms: ', self convention rooms size printString.
		html paragraph: 'Participants: ', self convention participants size printString.
	]! !

!CMHome methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:15'!
title
	^'Home'! !

CMComponent subclass: #CMLister
	instanceVariableNames: 'viewer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

CMLister subclass: #CMEvents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMEvents methodsFor: 'data-access' stamp: 'srh 5/31/2007 23:01'!
addItem: anEvent
	self convention addEvent: anEvent! !

!CMEvents methodsFor: 'specialisation' stamp: 'srh 5/31/2007 22:31'!
editorClass
	^CMEventEditor! !

!CMEvents methodsFor: 'data-access' stamp: 'srh 5/31/2007 21:26'!
items
	^self convention events! !

!CMEvents methodsFor: 'data-access' stamp: 'srh 5/31/2007 22:54'!
newItem
	^CMEvent new.! !

!CMEvents methodsFor: 'rendering' stamp: 'srh 6/3/2007 20:13'!
renderHeadersOn: html
	html tableHeading: 'Name'.
	html tableHeading: 'Room'.
	html tableHeading: 'Day'.
	html tableHeading: 'Time'.
	html tableHeading: 'Ptpts'.
! !

!CMEvents methodsFor: 'rendering' stamp: 'srh 6/3/2007 20:13'!
renderRow: anEvent on: html
	html 
		tableData: [ 
			self selectField: anEvent name callback: [ self item: anEvent ] on: html
		].
	anEvent scheduled ifTrue: [
		html
			tableData: anEvent room name;
			tableData: anEvent time dayOfWeekAbbreviation, ', ', (anEvent time asDate printFormat: #(2 1 0 ' ' 2 1));
			tableData: (String streamContents: [ :aStream | anEvent time asTime print24: true showSeconds: false on: aStream ])
	] ifFalse: [
		html
			tableData colSpan: 3; align: #center; with: [ html emphasis: '(unscheduled)' ]
	].
	html tableData class: 'num'; with: anEvent participants size printString.! !

!CMEvents methodsFor: 'specialisation' stamp: 'srh 5/31/2007 21:13'!
title
	^'Events'! !

!CMEvents methodsFor: 'specialisation' stamp: 'srh 5/31/2007 22:31'!
viewerClass
	^CMEventView! !

!CMLister methodsFor: 'actions' stamp: 'srh 5/31/2007 22:25'!
add
	| p editor |
	p := self newItem.
	editor := self editorClass for: p.
	(self lightbox: editor) ifTrue: [ self addItem: p ]! !

!CMLister methodsFor: 'data-access' stamp: 'srh 5/31/2007 22:25'!
addItem: anItem
	^self subclassResponsibility.! !

!CMLister methodsFor: 'accessing' stamp: 'srh 5/31/2007 22:26'!
children
	^Array with: viewer.! !

!CMLister methodsFor: 'actions' stamp: 'srh 5/31/2007 22:27'!
delete: anObject
	(self lightbox: (WAYesOrNoDialog new addMessage: 'Are you sure you want to delete ', anObject name, '?'; yourself))
		ifTrue: [
			self removeItem: anObject.
		]! !

!CMLister methodsFor: 'actions' stamp: 'srh 5/31/2007 22:27'!
edit: anObject
	self lightbox: (self editorClass for: anObject).! !

!CMLister methodsFor: 'specialisation' stamp: 'srh 5/31/2007 22:30'!
editorClass
	^self subclassResponsibility.! !

!CMLister methodsFor: 'testing' stamp: 'srh 5/31/2007 22:27'!
enabled
	^self convention notNil! !

!CMLister methodsFor: 'initialize-release' stamp: 'srh 5/31/2007 22:28'!
initialize
	super initialize.
	viewer := self viewerClass new.! !

!CMLister methodsFor: 'accessing' stamp: 'srh 5/31/2007 22:47'!
item: anItem
	viewer item: anItem! !

!CMLister methodsFor: 'data-access' stamp: 'srh 5/31/2007 22:31'!
items
	^self subclassResponsibility.! !

!CMLister methodsFor: 'data-access' stamp: 'srh 5/31/2007 22:24'!
newItem
	^self subclassResponsibility.! !

!CMLister methodsFor: 'data-access' stamp: 'srh 5/31/2007 22:27'!
removeItem: anItem
	^self subclassResponsibility.! !

!CMLister methodsFor: 'rendering' stamp: 'srh 6/3/2007 20:08'!
renderActionsFor: anItem on: html
	html tableData class: 'actions'; with: [ 
		html anchor callback: [ self delete: anItem ]; with: '(x)'
	].
! !

!CMLister methodsFor: 'rendering' stamp: 'srh 6/3/2007 20:11'!
renderContentOn: html
	| odd | odd := true.
	
	html div id: #content; with: [ self renderItemOn: html ].
	html div id: #sidebar; with: [
		html table: [
			html tableRow class: #head; with: [ self renderHeadersOn: html. html tableHeading: '' ].
			self items do: [ :i | 
				html tableRow 
					class: ( odd ifTrue: [ #odd ] ifFalse: [ #even ] );
					with: [ 
						self renderRow: i on: html.
						self renderActionsFor: i on: html ].
				odd := odd not.
			]
		].
		html anchor callback: [ self add ]; with: 'Add'.
	]
! !

!CMLister methodsFor: 'rendering' stamp: 'srh 5/31/2007 22:39'!
renderHeadersOn: html
	^self subclassResponsibility.! !

!CMLister methodsFor: 'rendering' stamp: 'srh 5/31/2007 22:29'!
renderItemOn: html
	html render: viewer ! !

!CMLister methodsFor: 'rendering' stamp: 'srh 5/31/2007 22:40'!
renderRow: anItem on: html
	^self subclassResponsibility.! !

!CMLister methodsFor: 'rendering' stamp: 'srh 6/3/2007 22:00'!
selectField: data callback: aBlock on: html
	(self 
		updateId: #content
		callback: aBlock
		perform: #renderItemOn: 
		on: html) with:  data! !

!CMLister methodsFor: 'specialisation' stamp: 'srh 5/31/2007 22:30'!
viewerClass
	^self subclassResponsibility.! !

CMLister subclass: #CMParticipants
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMParticipants methodsFor: 'data-access' stamp: 'srh 5/31/2007 23:58'!
addItem: anItem
	self convention addParticipant: anItem! !

!CMParticipants methodsFor: 'specialisation' stamp: 'srh 5/31/2007 23:59'!
editorClass
	^CMParticipantEditor! !

!CMParticipants methodsFor: 'data-access' stamp: 'srh 5/31/2007 23:58'!
items
	^self convention participants! !

!CMParticipants methodsFor: 'data-access' stamp: 'srh 5/31/2007 23:58'!
newItem
	^CMParticipant new! !

!CMParticipants methodsFor: 'data-access' stamp: 'srh 5/31/2007 23:58'!
removeItem: anItem
	self convention removeParticipant: anItem! !

!CMParticipants methodsFor: 'rendering' stamp: 'srh 5/31/2007 23:56'!
renderHeadersOn: html
	html tableHeading: 'Name'.
	html tableHeading: 'Events'! !

!CMParticipants methodsFor: 'rendering' stamp: 'srh 6/3/2007 20:12'!
renderRow: aParticipant on: html
	html tableData: 
		[ self selectField: aParticipant name callback: [ self item: aParticipant ] on: html ].
	html tableData 
		class: #num; 
		with: aParticipant events size printString! !

!CMParticipants methodsFor: 'specialisation' stamp: 'srh 5/31/2007 21:07'!
title
	^'Participants'! !

!CMParticipants methodsFor: 'specialisation' stamp: 'srh 5/31/2007 23:59'!
viewerClass
	^CMParticipantView! !

CMLister subclass: #CMRooms
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:04'!
addItem: anItem
	^self convention addRoom: anItem! !

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:03'!
editorClass
	^CMRoomEditor! !

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:05'!
items
	^self convention rooms! !

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:04'!
newItem
	^CMRoom new! !

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:04'!
removeItem: anItem
	^self convention removeRoom: anItem! !

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:05'!
renderHeadersOn: html
	html tableHeading: 'Name'.
	html tableHeading: 'Events'.! !

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:07'!
renderRow: anItem on: html
	html tableData: [ self selectField: anItem name callback: [ self item: anItem ] on: html ].
	html tableData: anItem events size printString.! !

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:03'!
title
	^'Rooms'! !

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:03'!
viewerClass
	^CMRoomView! !

CMComponent subclass: #CMLoadSave
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:16'!
enabled
	^true! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:17'!
renderContentOn: html
	self convention ifNotNil: [
		self renderSaveBoxOn: html.
	].
	self renderLoadListOn: html.! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:17'!
renderLoadListOn: html
	html unorderedList: [
		CMConvention listSaved do: [ :name |
			html listItem: [
				html anchor callback: [
					 self session convention: (CMConvention loadFrom: name) 
				]; with: name.
			]
		]
	].! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:17'!
renderSaveBoxOn: html
	html form: [
		html label for: 'saveCon'.
		html textInput id: 'saveCon'; callback: [ :val |
			self convention saveAs: val.	
		].
		html submitButton value: 'Save'.
	]! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:15'!
title
	^'Load and Save'! !

CMComponent subclass: #CMViewer
	instanceVariableNames: 'item'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

CMViewer subclass: #CMEventView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMEventView methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 20:27'!
renderItemContentOn: html
	html paragraph class: #label; with: 'Info'.
	html paragraph 
		script: (self inPlaceEditorFor: #description on: html rows: 6);
		with: self item description .
! !

CMViewer subclass: #CMParticipantView
	instanceVariableNames: 'mode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 22:07'!
initialize
	super initialize.
	mode := #details! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 21:24'!
renderDetailsOn: html
	html paragraph class: #label; with: 'Bio'.
	html paragraph 
		script: (self inPlaceEditorFor: #bio on: html rows: 6);
		with: self item bio asHtml .
! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 21:43'!
renderEventsOn: html
	| t lastDate |
	t := SortedCollection sortBlock: [ :a :b | 
		(a scheduled and: [ b scheduled ]) 
			ifTrue: [a time < b time] 
			ifFalse: [
				a scheduled 
					ifTrue: [b]
					ifFalse: [b scheduled ifTrue: [a] ifFalse: [ a name < b name ] ]
			]
	].
	item events do: [ :event | 
		t add: event
	].

	lastDate := nil.
	html table: [
		html 
			tableRow: [
				html 
					tableHeading: 'Date';
					tableHeading: 'Time';
					tableHeading: 'Event';
					tableHeading: 'Duration';
					tableHeading: 'Room'.
				].
		t do: [ :e |
			e scheduled ifTrue: [ 
				(lastDate = e time day) 
					ifFalse: [ html tableData: e time dayOfWeekAbbreviation, ', ', (e time asDate printFormat: #(2 1 0 ' ' 2 1)) ] 
					ifTrue: [ html tableData ].
				html tableData: (String streamContents: [ :aStream | e time asTime print24: true showSeconds: false on: aStream ]).
				lastDate := e time day.
			] ifFalse: [
				(lastDate = #unscheduled) 
					ifFalse: [ html tableData colSpan: 2; with: '(Unscheduled)' ] 
					ifTrue: [ html tableData colSpan: 2].
				lastDate := #unscheduled.
			].
		
			html tableData: e name.
			html tableData: e duration.
			html tableData: (e scheduled ifTrue: [ e room name ])
		]
	]

"			tableData: anEvent time dayOfWeekAbbreviation, ', ', (anEvent time asDate printFormat: #(2 1 0 ' ' 2 1));
			tableData: (String streamContents: [ :aStream | anEvent time asTime print24: true showSeconds: false on: aStream ])
"! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 22:11'!
renderItemContentOn: html
	(mode = #details) ifTrue: [self renderDetailsOn: html ].
	(mode = #events) ifTrue: [self renderEventsOn: html ].
	html span class: #fixFloats ! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 22:08'!
renderNavOn: html
	#(#details #events) do: [ :m |
		html listItem 
			class: ((mode = m) ifTrue: [#active]);
			with: [
				html anchor 
					callback: [ mode := m ];
					onClick:(self session ajax ifTrue: [
						(html evaluator callback: [ :script | 
								mode := m.
								script element id: #viewContent; render: [ :r | self renderItemContentOn: r ].
								(script element up) siblings invoke: #removeClassName arguments: (Array with: #active).
								script element up;  addClassName: #active.
							]; 
							return: false)
					]);
					with: m asCapitalizedPhrase.
			]
		].
! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 23:13'!
style ^ 'div#participantView {
    border-style: solid;
    border-width: 1px;
}

#participantView h3 {
    margin-top: 0;
}
'! !

CMViewer subclass: #CMRoomView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMRoomView methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 20:33'!
renderItemContentOn: html
	html paragraph class: #label; with: 'Capacity'.
	html paragraph
		script: (self inPlaceEditorFor: #capacity on: html);
		with: self item capacity.
		
	html paragraph class: #label; with: 'Info'.	
	html paragraph 
		script: (self inPlaceEditorFor: #description on: html rows: 6);
		with: self item description .
! !

!CMViewer class methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 22:06'!
for: anItem
	^self new item: anItem; yourself.! !

!CMViewer methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 21:48'!
inPlaceEditorFor: aSelector on: html
	^self inPlaceEditorFor: aSelector on: html rows: 1 cols: nil.! !

!CMViewer methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 21:50'!
inPlaceEditorFor: aSelector on: html rows: rows
	^self inPlaceEditorFor: aSelector  on:  html rows: rows cols: nil! !

!CMViewer methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 21:16'!
inPlaceEditorFor: aSelector on: html rows: rows cols: cols 
	| setter |
	setter := (aSelector, ':') asSymbol.
	
	^(self session inlineEdit 
			ifTrue: [html inPlaceEditor 
				cancelLink: false;
				triggerInPlaceEditor: [ :value | item perform: setter with: value ];
				rows: rows;
				cols: cols;
				callback: [ :r | r render: (item perform: aSelector) asHtml]
			])! !

!CMViewer methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 21:37'!
item
	^item! !

!CMViewer methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 22:52'!
item: anItem
	item := anItem! !

!CMViewer methodsFor: 'rendering' stamp: 'srh 6/3/2007 22:11'!
renderContentOn: html
	item ifNotNil: [
		html div id: 'view'; with: [
			self renderHeadingOn: html.
			html unorderedList 
				class: #itemTabs;
				with: [ self renderNavOn: html ].
			html div 
				id: #viewContent; 
				with: [	self renderItemContentOn: html]
		]
	].! !

!CMViewer methodsFor: 'rendering' stamp: 'srh 6/3/2007 20:22'!
renderHeadingOn: html
	item ifNotNil: [
		html heading 
			level: 3;
			script: (self inPlaceEditorFor: #name on: html);
		 	with: item name.
	]! !

!CMViewer methodsFor: 'rendering' stamp: 'srh 6/3/2007 20:20'!
renderItemContentOn: html
	^self subclassResponsibility! !

!CMViewer methodsFor: 'rendering' stamp: 'srh 6/3/2007 20:32'!
renderNavOn: html
	item ifNotNil: [
		html listItem class: #active; with: 'Details'
	].! !

Object subclass: #CMConvention
	instanceVariableNames: 'rooms events participants name'
	classVariableNames: 'Suffix Prefix'
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:44'!
deserialize: aString
	^Object readSixxFrom: aString! !

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:47'!
filenameFrom: aFilename
	" Use a template to create a filename from the unique portion "
	^ Prefix, aFilename , Suffix.! !

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:48'!
initialize
	super initialize.
	Prefix := 'Conman-'.
	Suffix := '.xml'.! !

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:49'!
listSaved
	^ (FileDirectory default fileNamesMatching: Prefix, '*', Suffix) collect: [ :n|
		n copyFrom: Prefix size + 1 to: n size - Suffix size ].! !

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:29'!
loadFrom: aFilename
	| fstream c |
	fstream := FileDirectory default readOnlyFileNamed: (self filenameFrom: aFilename).
	c := Object readSixxFrom: fstream.
	fstream close.
	^c.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:49'!
addEvent: anEvent
	events add: anEvent.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:50'!
addParticipant: aParticipant
	participants add: aParticipant! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:49'!
addRoom: aRoom
	rooms add: aRoom! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:48'!
events
	^events! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:38'!
initialize
	rooms := Set new.
	events := Set new.
	participants := Set new.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:11'!
name
	^name! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:10'!
name: aName
	name := aName.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:48'!
participants
	^participants! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:09'!
removeEvent: anEvent
	anEvent dispose.
	events remove: anEvent.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:17'!
removeParticipant: aParticipant
	aParticipant dispose.
	participants remove: aParticipant.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:11'!
removeRoom: aRoom
	aRoom dispose.
	rooms remove: aRoom.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:48'!
rooms
	^rooms! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:26'!
saveAs: aFilename
	| fstream |
	fstream := FileDirectory default forceNewFileNamed: (CMConvention filenameFrom: aFilename).
	fstream write: self serialize.
	fstream close.
! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:43'!
serialize
	" Convert the Convention and its members to a string that can be used
	 to reconstitute the Convention via CMConvention deserialise:"
	
	^self sixxString.! !

Object subclass: #CMEvent
	instanceVariableNames: 'description duration name participants room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/23/2007 23:21'!
add: aParticipant
	participants add: aParticipant.
	aParticipant myAddEvent: self! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:38'!
deschedule
	room ifNotNil: [room deschedule: self].! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
description
	^ description! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
description: anObject
	description := anObject! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:10'!
dispose
	self deschedule.
	participants do: [ :p | self remove: p].! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
duration
	^ duration! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
duration: anObject
	duration := anObject! !

!CMEvent methodsFor: 'initialize-release' stamp: 'srh 5/23/2007 22:32'!
initialize
	participants := Set new! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
name
	^ name! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
name: anObject
	name := anObject! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
participants
	^ participants! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 07:22'!
remove: aParticipant
	participants remove: aParticipant.
	aParticipant myRemoveEvent: self! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/24/2007 15:16'!
room
	^room! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:12'!
scheduleAt: aTime in: aRoom
	aRoom schedule: self at: aTime.! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:07'!
scheduled
	^room notNil.! !

!CMEvent methodsFor: 'private' stamp: 'srh 5/24/2007 15:08'!
setRoom: aRoom
	room := aRoom! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:16'!
time
	^ room scheduleFor: self! !

Object subclass: #CMParticipant
	instanceVariableNames: 'bio name events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

CMParticipant class
	instanceVariableNames: 'events'!

CMParticipant class
	instanceVariableNames: 'events'!

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/23/2007 23:23'!
attend: anEvent
	anEvent add: self! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
bio
	^ bio! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
bio: anObject
	bio := anObject! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:18'!
dispose
	events do: [ :e | self unattend: e].! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 23:20'!
events
	^events! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 20:22'!
initialize
	events := Set new.
	bio := ''! !

!CMParticipant methodsFor: 'private' stamp: 'srh 5/23/2007 23:19'!
myAddEvent: anEvent
	events add: anEvent.! !

!CMParticipant methodsFor: 'private' stamp: 'srh 5/24/2007 07:22'!
myRemoveEvent: anEvent
	events remove: anEvent! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:16'!
name
	^ name! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
name: anObject
	name := anObject! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:16'!
timetable
	| t |
	t := SortedCollection sortBlock: [ :a :b | a time < b time].
	events do: [ :event | 
		event scheduled ifTrue: [
			t add: (CMScheduleItem newEvent: event in: event room at: event time) 
		]].
	^t.! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 07:19'!
unattend: anEvent
	anEvent remove: self! !

Object subclass: #CMRoom
	instanceVariableNames: 'capacity description name schedule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
capacity
	^ capacity! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
capacity: anObject
	capacity := anObject! !

!CMRoom methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:27'!
deschedule: anEvent
	(schedule includesKey: anEvent) ifTrue: [
		schedule removeKey: anEvent.
		anEvent setRoom: nil.
	].! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
description
	^ description! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
description: anObject
	description := anObject! !

!CMRoom methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:14'!
dispose
	schedule keys do: [ :e | self deschedule: e ].! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/24/2007 15:15'!
events
	^schedule keys! !

!CMRoom methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 20:22'!
initialize
	schedule := Dictionary new.
	description := ''! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:16'!
name
	^ name! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
name: anObject
	name := anObject! !

!CMRoom methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:37'!
schedule: anEvent at: aDateAndTime
	anEvent deschedule.
	schedule at: anEvent put: aDateAndTime.
	anEvent setRoom: self! !

!CMRoom methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:15'!
scheduleFor: anEvent
	^schedule at: anEvent! !

Object subclass: #CMScheduleItem
	instanceVariableNames: 'room event time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMScheduleItem class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:09'!
newEvent: anEvent in: aRoom at: aTime
	^(self new) setEvent: anEvent room: aRoom time: aTime.! !

!CMScheduleItem methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:06'!
event
	^event! !

!CMScheduleItem methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:06'!
room
	^room! !

!CMScheduleItem methodsFor: 'private' stamp: 'srh 5/24/2007 20:09'!
setEvent: anEvent room: aRoom time: aTime
	room := aRoom.
	event := anEvent.
	time := aTime.! !

!CMScheduleItem methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:06'!
time
	^time! !

WASession subclass: #CMSession
	instanceVariableNames: 'convention ajax inlineEdit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 23:31'!
ajax
	^ajax! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 23:31'!
ajax: aBoolean
	ajax := aBoolean! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:18'!
convention
	^convention.! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:18'!
convention: aCMConvention
	convention := aCMConvention.! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 01:09'!
initialize
	super initialize.
	ajax := true.
	inlineEdit := true.! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 20:41'!
inlineEdit
	^ajax and: inlineEdit! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 20:34'!
inlineEdit: aBoolean
	inlineEdit := aBoolean! !

TestCase subclass: #CMConventionTest
	instanceVariableNames: 'c e r p time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:09'!
assertDeserialization: c2
	" Check that c2 is the same as c as set up by standardSetUp"
	| e2 r2 p2 tt |

	self assert: c name = c2 name.
	
	" Verify the basic collections are the same - as far as we can "
	self assert: c rooms size = c2 rooms size.
	self assert: c events size = c2 events size.
	self assert: c participants size = c2 participants size .

	" Now ensure the relationships are kept "
	e2 := c2 events asOrderedCollection at: 1.
	r2 := c2 rooms asOrderedCollection at: 1.
	p2 := c2 participants asOrderedCollection at: 1.
	tt := p2 timetable at: 1.
		
	self assert: r2 = e2 room.
	self assert: e2 = (r2 events asOrderedCollection at: 1).
	self assert: e2 = tt event.
	self assert: r2 = tt room.
	self assert: time = tt time.
	! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:24'!
setUp
	c := CMConvention new name: 'A Convention'.
	e := CMEvent new name: 'An Event'; description: 'Stuff Happens'.
	r := CMRoom new name: 'A Room'; description: 'It has four walls'; capacity: '20'.
	p := CMParticipant new name: 'A Participant'.
	time := '2007-10-01T10:00:00' asDateAndTime.
! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:22'!
standardSetUp
	c addEvent: e; addRoom: r; addParticipant: p.
	p attend: e.
	r schedule: e at: time.
! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:17'!
tearDown
	c := nil.
	e := nil.
	r := nil.
	p := nil.
	time := nil.! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:00'!
testAddEvents
	c addEvent: e.
	self assert: (c events includes: e).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:00'!
testAddParticipants
	c addParticipant: p.
	self assert: (c participants includes: p).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:00'!
testAddRooms
	c addRoom: r.
	self assert: (c rooms includes: r).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:21'!
testLoadSave
	| c2 |
	self standardSetUp.
	c saveAs: 'testingfile'.
	
	c2 := CMConvention loadFrom: 'testingfile'.
	self assertDeserialization: c2.! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:17'!
testRemoveEvent
	self	standardSetUp.
	c removeEvent: e.
	
	self assert: (c events includes: e) not.
	self assert: (r events includes: e) not.
	self assert: (p events includes: e) not.! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:17'!
testRemoveParticipant
	self standardSetUp.
	
	c removeParticipant: p.
	
	self assert: (c participants includes: p) not.
	self assert: (e participants includes: p) not.
! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:18'!
testRemoveRoom
	self standardSetUp.
		
	c removeRoom: r.
	
	self assert: (c rooms includes: r) not.
	self assert: (e scheduled) not.
	self assert: e room isNil.
	self assert: (p timetable noneSatisfy: [ :s | s room = r ]).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:19'!
testSerialiseDeserialise
	| c2 string |
	self standardSetUp.
	string := c serialize.
	
	c2 := CMConvention deserialize: string.
	self assertDeserialization: c2.! !

TestCase subclass: #CMEventTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:16'!
assert: anEvent scheduledAt: aDateAndTime in: aRoom
	self assert: anEvent scheduled.
	self assert: (aRoom events includes: anEvent).
	self assert: (aRoom scheduleFor: anEvent) = aDateAndTime.
	self assert: anEvent time = aDateAndTime.
	self assert: anEvent room == aRoom! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 14:57'!
testAdd
	| p e |
	e := CMEvent new.
	p := CMParticipant new.
	e add: p.
	self assert: e participants size = 1.
	self assert: (e participants includes: p).
	self assert: p events size = 1.
	self assert: (p events includes: e).! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:24'!
testDeschedule
	| e1 r1 |
	r1 := CMRoom new.
	e1 := CMEvent new.
	
	e1 scheduleAt: '2007-10-01T09:00:00' asDateAndTime in: r1.	
	e1 deschedule.
	self assert: r1 events size = 0.
	
! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 07:16'!
testRemove
	| e1 p1 |
	p1 := CMParticipant new.
	e1 := CMEvent new.
	
	e1 add: p1.
	e1 remove: p1.
	self assert: e1 participants size = 0.
	self assert: p1 events size = 0.! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:25'!
testReschedule
	| e1 r1 r2 t1 t2 |
	r1 := CMRoom new.
	r2 := CMRoom new.
	e1 := CMEvent new.
	t1 := '2007-10-01T09:00:00' asDateAndTime.
	t2 := '2007-10-02T17:00:00' asDateAndTime.
	
	e1 scheduleAt: t1 in: r1.	
	e1 scheduleAt: t2 in: r1.
	self assert: e1 scheduledAt: t2 in: r1.
	
	self assert: r1 events size = 1.
	
	e1 scheduleAt: t1 in: r2.
	self assert: e1 scheduledAt: t1 in: r2.
	self assert: r1 events size = 0.
	
	e1 deschedule.
	self assert: r1 events size = 0.
	self assert: r2 events size = 0.
	self assert: e1 scheduled not.
	
! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:23'!
testSchedule
	| e1 r1 t1 |
	r1 := CMRoom new.
	e1 := CMEvent new.
	t1 := '2007-10-01T09:00:00' asDateAndTime.
	
	e1 scheduleAt: t1 in: r1.	
	self assert: e1 scheduledAt: t1 in: r1.! !

TestCase subclass: #CMParticipantTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMParticipantTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 14:58'!
testAttend
	| p e |
	e := CMEvent new.
	p := CMParticipant new.
	p attend: e.
	self assert: p events size = 1.
	self assert: (p events includes: e).
	self assert: e participants size = 1.
	self assert: (e participants includes: p).
! !

!CMParticipantTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:14'!
testTimetable
	| e1 r1 e2 r2 p t1 t2 |
	
	p := CMParticipant new.
	e1 := CMEvent new.
	e2 := CMEvent new.
	r1 := CMRoom new.
	r2 := CMRoom new.
	t1 := '2007-10-01T09:30:00' asDateAndTime.
	t2 := '2007-10-01T015:00:00' asDateAndTime.

	r1 schedule: e1 at: t1.
	r2 schedule: e2 at: t2.
	
	p attend: e1.
	p attend: e2.
	
	self assert: (p timetable at: 1) room = r1.
	self assert: (p timetable at: 1) event = e1.
	self assert: (p timetable at: 1) time = t1.
	
	self assert: (p timetable at: 2) room = r2.
	self assert: (p timetable at: 2) event = e2.
	self assert: (p timetable at: 2) time = t2.! !

!CMParticipantTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 07:20'!
testUnattend
	| e1 p1 |
	p1 := CMParticipant new.
	e1 := CMEvent new.
	
	e1 add: p1.
	p1 unattend: e1.
	self assert: e1 participants size = 0.
	self assert: p1 events size = 0.! !

TestCase subclass: #CMRoomTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMRoomTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:16'!
assert: anEvent scheduledAt: aDateAndTime in: aRoom
	self assert: anEvent scheduled.
	self assert: (aRoom events includes: anEvent).
	self assert: (aRoom scheduleFor: anEvent) = aDateAndTime.
	self assert: anEvent time = aDateAndTime.
	self assert: anEvent room == aRoom! !

!CMRoomTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:00'!
testDeschedule
	| e1 r1 |
	r1 := CMRoom new.
	e1 := CMEvent new.
	
	r1 schedule: e1 at: '2007-10-01T09:00:00' asDateAndTime.
	r1 deschedule: e1.
	self assert: r1 events size = 0.
	
! !

!CMRoomTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:03'!
testReschedule
	| e1 r1 r2 t1 t2 |
	r1 := CMRoom new.
	r2 := CMRoom new.
	e1 := CMEvent new.
	t1 := '2007-10-01T09:00:00' asDateAndTime.
	t2 := '2007-10-02T17:00:00' asDateAndTime.
	
	r1 schedule: e1 at: t1.	
	r1 schedule: e1 at: t2.
	self assert: e1 scheduledAt: t2 in: r1.
	self assert: r1 events size = 1.
	
	r2 schedule: e1 at: t1.
	self assert: e1 scheduledAt: t1 in: r2.
	self assert: r1 events size = 0.
	
	r2 deschedule: e1.
	self assert: r1 events size = 0.
	self assert: r2 events size = 0.
	self assert: e1 scheduled not.
	
! !

!CMRoomTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:03'!
testSchedule
	| e1 r1 t1 |
	r1 := CMRoom new.
	e1 := CMEvent new.
	t1 := '2007-10-01T09:00:00' asDateAndTime.
	
	r1 schedule: e1 at: t1.	
	self assert: e1 scheduledAt: t1 in: r1.! !
CMConvention initialize!
